<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="modal">
        <div class="modal-mask"></div>
        <button class="close-btn button-icon" @click="closeModal();">
            <i class="icon-close"></i>
        </button>
        <div class="modal-wrapper">
            <div class="modal-sidebar">
                <div>
                    <h2>Create <br>New <br>Term</h2>
                    <div>
                        <nav>
                            <ul>
                                <li :class="{ 'active': currentStep === 1 }"><div><span>1</span>Term Info</div></li>
                                <li :class="{ 'active': currentStep === 2 }"><div><span>2</span>Confirmation</div></li>
                            </ul>
                        </nav>
                    </div>
                </div>
                <div>
                    <div class="info user">
                        <h3>Owner</h3>
                        <UserProfile />
                    </div>
                    <InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
                </div>
            </div>
            <div class="modal-content">
                <!-- ==== STEP 1 - Term Info ====  -->
                <div id="step-1" class="step" v-show="currentStep === 1">
                    <form id="dataset-step-1" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">1</span>
                            <h2>Term info</h2>
                            <p>Add new terms to our glossary to facilitate understanding and consistent use of
                                terminology. Provide a clear and concise definition to help other users understand the
                                term accurately.</p>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>1.</span>Term name</label>
                                <input type="text" name="name" required v-model="termsData.name" data-error-message="Fill in this field." />
                            </div>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>2.</span>Fill in with the Basic Info</label>
                            </div>
                            <div class="modal-boxs-wrapper">
                                <div class="modal-input col-100">
                                    <label for="full-description">Full description</label>
                                    <input type="text" name="full-description" id="full-description" required
                                        minlength="3" v-model="termsData.description" data-error-message="Fill in this field." />
                                </div>
                                <div class="modal-input col-100">
                                    <label for="short-description">Short description</label>
                                    <input type="text" name="short-description" id="short-description" required
                                        minlength="3" v-model="termsData.summary" data-error-message="Fill in this field." />
                                </div>
                                <div class="modal-input col-100">
                                    <label for="abbreviation">Abbreviation</label>
                                    <input type="text" name="abbreviation" id="abbreviation" required minlength="3" v-model="termsData.abbreviation" data-error-message="Fill in this field." />
                                </div>
                                <div class="modal-input col-100">
                                    <label for="usage">Usage</label>
                                    <input type="text" name="usage" id="usage" required minlength="3" v-model="termsData.usage" data-error-message="Fill in this field." />
                                </div>
                            </div>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>3.</span>Set the relations for this term</label>
                            </div>
                            <div class="modal-boxs-wrapper">
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Terms - Antonyms</h3>
                                        <div class="search-wrapper">
                                            <input type="text" v-model="searchTermAntonyms" name="platform-search" class="input-search" @input="onSearch('antonyms')">
                                        </div>
                                    </div>
                                    <div class="modal-list">
                                        <div class="modal-list-item" v-for="vocabulary in vocabularies"
                                            :key="vocabulary?.id" @click="toggleClass(vocabulary.id)"
                                            :class="{ active: isActive(vocabulary?.id) || hasMatchingTerm(vocabulary, 'antonyms') }">
                                            <div class="item-title">
                                                <label class="form-group-checkbox">
                                                    <input 
                                                        type="checkbox" 
                                                        @click.stop="toggleAllTerms(vocabulary.id, 'antonyms')"
                                                        :checked="areAllTermsSelected(vocabulary.id, 'antonyms')" 
                                                    />
                                                    <div class="checkbox__checkmark"></div>
                                                </label>
                                                <h3>{{ vocabulary?.name }} <sup v-if="vocabulary?.total > 0">{{
                                                    vocabulary?.total }}</sup></h3>
                                                <i class="icon-arrow-down"></i>
                                            </div>
                                            <div class="list" @click.stop>
                                                <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                                    <li v-for="term in visibleTerms(vocabulary, 'antonyms')" :key="term?.id">
                                                        <input 
                                                            type="checkbox" 
                                                            :id="`term-antonym-${vocabulary?.id}-${term?.id}`"
                                                            @click.stop="toggleTerm(vocabulary.id, term.id, 'antonyms')"
                                                            :checked="selectedAntonymTerms[vocabulary.id]?.has(term.id) || false"
                                                        />
                                                        <label :for="`term-antonym-${vocabulary?.id}-${term?.id}`">{{ term?.name }}</label>
                                                    </li>

                                                    <!-- See More button to display the rest of the terms -->
                                                    <li v-if="!isShowingAllAntonyms[vocabulary.id] && filteredTerms(vocabulary, 'antonyms').length > 5">
                                                        <span class="see-more-terms" @click="showMoreTerms(vocabulary.id, 'antonyms')">
                                                            <i class="icon-add add"></i>
                                                            {{ filteredTerms(vocabulary, 'antonyms').length - 5 }}
                                                            <i class="icon-arrow-down arrow"></i>
                                                        </span>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Terms - Synonyms</h3>
                                        <div class="search-wrapper">
                                            <input type="text" v-model="searchTermSynonyms" name="platform-search" class="input-search" @input="onSearch('synonyms')">
                                        </div>
                                    </div>
                                    <div class="modal-list">
                                        <div class="modal-list-item" v-for="vocabulary in vocabularies"
                                            :key="vocabulary?.id" @click="toggleClass(vocabulary.id)"
                                            :class="{ active: isActive(vocabulary?.id) || hasMatchingTerm(vocabulary, 'synonyms') }">
                                            <div class="item-title">
                                                <label class="form-group-checkbox">
                                                    <input 
                                                        type="checkbox" 
                                                        @click.stop="toggleAllTerms(vocabulary.id, 'synonyms')"
                                                        :checked="areAllTermsSelected(vocabulary.id, 'synonyms')"
                                                    />
                                                    <div class="checkbox__checkmark"></div>
                                                </label>
                                                <h3>{{ vocabulary?.name }} <sup v-if="vocabulary?.total > 0">{{
                                                    vocabulary?.total }}</sup></h3>
                                                <i class="icon-arrow-down"></i>
                                            </div>
                                            <div class="list" @click.stop>
                                                <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                                    <li v-for="term in visibleTerms(vocabulary, 'synonyms')" :key="term?.id">
                                                        <input 
                                                            type="checkbox" 
                                                            :id="`term-synonym-${vocabulary?.id}-${term?.id}`"
                                                            @click.stop="toggleTerm(vocabulary.id, term.id, 'synonyms')"
                                                            :checked="selectedSynonymTerms[vocabulary.id]?.has(term.id) || false"
                                                        />
                                                        <label :for="`term-synonym-${vocabulary?.id}-${term?.id}`">{{ term?.name }}</label>
                                                    </li>

                                                    <!-- See More button to display the rest of the terms -->
                                                    <li v-if="!isShowingAllSynonyms[vocabulary.id] && filteredTerms(vocabulary, 'synonyms').length > 5">
                                                        <span class="see-more-terms" @click="showMoreTerms(vocabulary.id, 'synonyms')">
                                                            <i class="icon-add add"></i>
                                                            {{ filteredTerms(vocabulary, 'synonyms').length - 5 }}
                                                            <i class="icon-arrow-down arrow"></i>
                                                        </span>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>

                <!-- ==== STEP 2 - Confirmation === -->
                <div id="step-2" class="step" v-show="currentStep === 2">
                    <div class="title">
                        <span class="step-number">2</span>
                        <h2>Confirmation</h2>
                        <p>Your term has been created. Please review the details below to confirm everything is correct.</p>
                    </div>
                    <div class="confirmation-wrapper">
                        <div class="confirmation-wrapper-values">
                            <div class="card-values">
                                <div class="card-values-number">{{ totalSynonyms }}</div>
                                <div class="card-values-text">synonyms</div>
                            </div>
                            <div class="card-values">
                                <div class="card-values-number">{{ totalAntonyms }}</div>
                                <div class="card-values-text">antonyms</div>
                            </div>
                        </div>
                        <button class="button-secondary orange" @click="closeModal">Confirm Details</button>
                    </div>
                </div>

            </div>
            <div class="modal-buttons-area">
                <button :class="['button-stroke-transparent rounded', currentStep === 1 && 'hide']" id="previous-step"
                    @click="previousStep">Back</button>
                <!-- <button class="button-secondary orange" id="next-step" @click="handleNextClick" v-if="currentStep !== 2">Create</button> -->
                <button class="button-secondary orange" id="next-step" @click="handleNextClick"
                    v-if="currentStep !== 2">Create</button>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">

import { generateUUID, highlightInvalidFields, removeHtmlTags } from '~/utils/utils';
import type {vocabulariesArray } from '~/interfaces/types';
import { useDataStore } from '@/stores/dataStore';

const props = defineProps({
    glossaryId:{
        type: String,
        required: false
    },
    row: { 
        type: undefined as any, 
        required: false 
    },
    isEditMode: {
        type: Boolean,
        required: false
    }
});
const dataStore = useDataStore();
const emit = defineEmits(['toggle']);

const closeModal = () => {
    console.log('oiii fechei')
    emit('toggle');
    dataStore.triggerRefresh();
}

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);
const close = () => {
    showFeedback.value = false;
};

// modal navigation
const currentStep = ref<number>(1);
const totalSynonyms = ref(0);
const totalAntonyms = ref(0);

interface TermData {
    name: string;
    description: string;
    summary: string;
    abbreviation: string;
    usage: string;
}

const glossarySelected = ref('');

// select port on streaming step
const handleSelect = (selectedOption: string) => {
    glossarySelected.value = selectedOption;
}

// form submit step 1
const handleSubmit = () => {
    const form = document.getElementById('dataset-step-1') as HTMLFormElement;

    // if (currentStep.value === 1) {
    // Perform validation (if any)
    if (form && form?.checkValidity()) {

        const formData = new FormData(form);
        const uuid = generateUUID();

        const glossaryId = ref(props.glossaryId);

        if (!glossaryId.value) {
            glossaryId.value = glossarySelected.value
        }

        const data = {
            name: formData.get('name') as string,
            description: formData.get('full-description') as string,
            summary: formData.get('short-description') as string,
            abbreviation: formData.get('abbreviation') as string,
            usage: formData.get('usage') as string,
            glossaryId: glossaryId.value,
            examples: [
                'test',
                'test 2' 
            ]
        };

        if(props?.isEditMode){
            submitDataUpdate(data, props?.row);
        }else{
            submitData(data);
            form.reset();
        }

        clearAllValidationErrors(form);
        //nextStep();
    } else {
        highlightInvalidFields(form);
        console.log('Form is invalid, show error messages or handle accordingly.');
    }
}

const submitData = async (data: TermData) => {
    const { antonyms, synonyms } = collectSelectedTerms();
    totalSynonyms.value = synonyms.length;
    totalAntonyms.value = antonyms.length;

    try {
        useFetchAuth('/terms', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }).then((response: any) => {
            for (var i = 0; i < antonyms.length; i++) {
                relateTerms(String(antonyms[i]), response.id, 'ANTONYM');
            }

            for (var a = 0; a < synonyms.length; a++) {
                relateTerms(String(synonyms[a]), response.id, 'SYNONYM');
            }

            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'success',
                message: 'Term added successfully!',
            };
            setTimeout(() => {
                feedbackMessage.value = { type: '', message: '' };
                showFeedback.value = false;
                nextStep();
            }, 3000);
        }).catch((error) => {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error adding term:' + errorData,
            };
        });

    } catch (error) {
        showFeedback.value = true;
        feedbackMessage.value = {
            type: 'error',
            message: 'Error adding term:' + error,
        };
        console.error('Error during fetch:', error);
    }
}

const submitDataUpdate = async (data: TermData, id: string) => {
    const { antonyms, synonyms } = collectSelectedTerms();
    totalSynonyms.value = synonyms.length;
    totalAntonyms.value = antonyms.length;

    try {
        const responseOld = await useFetchAuth(`/terms/${id}`) as { synonyms: any, antonyms: any };

        if(responseOld?.synonyms?.length){
            await Promise.all(
                responseOld.synonyms.map((synonym: any) => removeAssociatedTerms(synonym?.relationId))
            )
        }

        if(responseOld?.antonyms?.length){
            await Promise.all(
                responseOld.antonyms.map((antonym: any) => removeAssociatedTerms(antonym?.relationId))
            )
        }

        useFetchAuth('/terms/' + id, { 
            method: 'PUT',
            headers: {
            'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }).then((response: any) => {
            for (var i = 0; i < antonyms.length; i++) {
                relateTerms(String(antonyms[i]), id, 'ANTONYM');
            }

            for (var a = 0; a < synonyms.length; a++) {
                relateTerms(String(synonyms[a]), id, 'SYNONYM');
            }

            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'success',
                message: 'Term updated successfully!',
            };
            setTimeout(() => {
                feedbackMessage.value = { type: '', message: '' };
                showFeedback.value = false;
                nextStep();
            }, 3000);
        }).catch((error) => {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error updating term:' + errorData,
            };
        });
        
    } catch (error) {
        showFeedback.value = true;
        feedbackMessage.value = {
            type: 'error',
            message: 'Error updating glossary:' + error,
        };
        console.error('Error during update:', error);
    }
}

const handleNextClick = () => {
    if (currentStep.value === 1) {
        // Trigger form submission and validation only on step 1
        handleSubmit();
    } else {
        // Proceed to the next step without form submission
        nextStep();
    }
}

const nextStep = () => {
    if (currentStep.value < 2) {
        currentStep.value++;
    }
}

const previousStep = () => {
    if (currentStep.value > 0) {
        currentStep.value--;
    }
}

const gotoStep = (step: number) => {
    currentStep.value = step;
}

const searchTermAntonyms = ref('');
const searchTermSynonyms = ref('');

// State to track selected checkboxes for antonyms and synonyms
const antonymCheckboxState = ref<Record<string | number, boolean>>({});
const synonymCheckboxState = ref<Record<string | number, boolean>>({});
const selectedAntonymTerms = ref<Record<string | number, Set<string | number>>>({});
const selectedSynonymTerms = ref<Record<string | number, Set<string | number>>>({});
    
// Track which vocabularies have their terms fully expanded
const isShowingAllAntonyms = ref<Record<string | number, boolean>>({});
const isShowingAllSynonyms = ref<Record<string | number, boolean>>({});

const termsData = ref({
    name: '',
    description: '',
    summary: '',
    usage: '',
    abbreviation: '',
    id: '',
    synonyms: [],
    antonyms: [],
    createdAt: '',
    updatedAt: '',
}); 

// Function to toggle showing all terms for a specific vocabulary
function showMoreTerms(vocabularyId: string | number, modalType: 'antonyms' | 'synonyms') {
  if (modalType === 'antonyms') {
    isShowingAllAntonyms.value[vocabularyId] = true;
  } else {
    isShowingAllSynonyms.value[vocabularyId] = true;
  }
}

// Function to filter terms within a vocabulary based on the global search term
const filteredTerms = (vocabulary: any, modalType: 'antonyms' | 'synonyms') => {
  const searchTerm = modalType === 'antonyms' ? searchTermAntonyms.value : searchTermSynonyms.value;
  if (!searchTerm) return vocabulary.terms;
  
  return vocabulary.terms.filter((term: { name: string }) =>
    term.name.toLowerCase().includes(searchTerm.toLowerCase())
  );
};

function onSearch(modalType: 'antonyms' | 'synonyms') {
  // Reset the "show more" state for all vocabularies when the search term is cleared
  if (modalType === 'antonyms' && !searchTermAntonyms.value) {
    isShowingAllAntonyms.value = {};
  } else if (modalType === 'synonyms' && !searchTermSynonyms.value) {
    isShowingAllSynonyms.value = {};
  }
}

// Function to return only the visible terms (first 5 or all if "See More" is clicked)
const visibleTerms = (vocabulary: any, modalType: 'antonyms' | 'synonyms') => {
  const terms = filteredTerms(vocabulary, modalType);

  const isShowingAll = modalType === 'antonyms'
    ? isShowingAllAntonyms.value[vocabulary.id]
    : isShowingAllSynonyms.value[vocabulary.id];

  if (isShowingAll || terms.length <= 5) {
    return terms;
  }

  return terms.slice(0, 5); // Otherwise, show only the first 5
};

// Function to check if any term in a vocabulary matches the search term
const hasMatchingTerm = (vocabulary: any, modalType: 'antonyms' | 'synonyms') => {
  return filteredTerms(vocabulary, modalType).length > 0;
};

const activeVocabularies = ref(new Set<number>());

/**
 * Toggles the given vocabulary ID in the activeVocabularies set.
 * If the vocabulary ID is already in the set, it is removed.
 * If the vocabulary ID is not in the set, it is added.
 * @param {number} id - the vocabulary ID
 */
const toggleClass = (id: number) => {
    if (activeVocabularies.value.has(id)) {
        activeVocabularies.value.delete(id);
    } else {
        activeVocabularies.value.add(id);
    }
};

/**
 * Returns true if the given vocabulary ID is in the activeVocabularies set and
 * false otherwise.
 * @param {number} id - the vocabulary ID to check
 * @return {boolean} whether the vocabulary ID is in the activeVocabularies set
 */
const isActive = (id: number) => {
    return activeVocabularies.value.has(id);
};

// Define available vocabularies and terms in the form as a reactive array
const vocabularies = ref<vocabulariesArray[]>([
    {
        id: 1,
        name: 'Mathematics',
        total: 31,
        terms: [
            {
                id: 1,
                name: 'Blockchain Tecnology',
            },
            {
                id: 2,
                name: 'Blockchain Tecnology',
            },
            {
                id: 3,
                name: 'Blockchain Tecnology',
            },
            {
                id: 4,
                name: 'Blockchain Tecnology',
            },
            {
                id: 5,
                name: 'Blockchain Tecnology',
            },
            {
                id: 6,
                name: 'Blockchain Tecnology',
            },
            {
                id: 7,
                name: 'Blockchain Tecnology',
            },
            {
                id: 8,
                name: 'Blockchain Tecnology',
            },
            {
                id: 9,
                name: 'Blockchain Tecnology',
            },
            {
                id: 10,
                name: 'Blockchain Tecnology',
            }
        ]
    },
    {
        id: 2,
        name: 'Computer Sciente / Finance',
        total: 29,
        terms: [
            {
                id: 1,
                name: 'Blockchain Tecnology',
            },
            {
                id: 2,
                name: 'Blockchain Tecnology',
            },
            {
                id: 3,
                name: 'Blockchain Tecnology',
            },
            {
                id: 4,
                name: 'Blockchain Tecnology',
            },
            {
                id: 5,
                name: 'Blockchain Tecnology',
            },
            {
                id: 6,
                name: 'Blockchain Tecnology',
            },
            {
                id: 7,
                name: 'Blockchain Tecnology',
            },
            {
                id: 8,
                name: 'Blockchain Tecnology',
            },
            {
                id: 9,
                name: 'Blockchain Tecnology',
            },
            {
                id: 10,
                name: 'Blockchain Tecnology',
            }
        ]
    },
    {
        id: 3,
        name: 'Medicine / Health Sciences',
        total: 0,
        terms: [
            {
                id: 1,
                name: 'Other',
            },

        ]
    }
])

/**
 * Fetch available vocabularies on API upon component mounting.
 */
onMounted(() => {
    // get vocabularies + terms
    useFetchAuth('/glossaries').then((response: any) => {
        vocabularies.value = [];
        for (let i = 0; i < response.length; i++) {

            // get terms
            vocabularies.value.push({
                id: response[i].id,
                name: response[i].name,
                total: response[i].terms.length,
                terms: response[i].terms
            });

        }
    });

    if (props.isEditMode && props.row) {
        fetchTermDetails(props.row);
    }
});

const fetchTermDetails = async (id: string) => {
    console.log('fetchTermDetails', id);
    try {
        const response = await useFetchAuth('/terms/' + id, { 
            method: 'GET',
            headers: {
            'Content-Type': 'application/json'
            }
        });

        if (response !== null) {
            const data = Array.isArray(response) ? response[0] : response;
            if(props.isEditMode && props.row){
                termsData.value = {
                    name: data.name || '',
                    description: removeHtmlTags(data.description) || '',
                    summary: data.summary || '',
                    usage: data.usage || '',
                    abbreviation: data.abbreviation || '',
                    id: data.id || '',
                    synonyms: data.synonyms || [],
                    antonyms: data.antonyms || [],
                    createdAt: data.createdAt || '',
                    updatedAt: data.updatedAt || '',
                }
            }else{
                termsData.value = {
                    name: '',
                    description: '',
                    summary: '',
                    usage: '',
                    abbreviation: '',
                    id: '',
                    synonyms: [],
                    antonyms: [],
                    createdAt: '',
                    updatedAt: '',
                }
            }
            
            initSelectedTerms(data);

            console.log('Data fetched successfully', termsData);
        } else {
            console.error('Error fetching data');
        }
    } catch (error) {
        console.error('Error during fetch:', error);
    }
}

watch(
  () => vocabularies.value,
  (newVocabularies) => {
    if (newVocabularies.length > 0 && props.isEditMode && props.row) {
      fetchTermDetails(props.row); // Ensure vocabularies are populated before fetching term details
    }
  },
  { immediate: true } // Run immediately in case vocabularies are already populated
);

function initSelectedTerms(data: any) {
  // Initialize selected antonyms
  data.antonyms.forEach((term: any) => {
    const termId = term.id; // Extract the term ID from the object
    for (const vocabulary of vocabularies.value) {
      // Check each term in the vocabulary's terms array
      const matchingTerm = vocabulary.terms.find((t: any) => t.id === termId);
      if (matchingTerm) {
        const vocabularyId = vocabulary.id;
        // Initialize selectedAntonymTerms if not already set
        if (!selectedAntonymTerms.value[vocabularyId]) {
          selectedAntonymTerms.value[vocabularyId] = new Set();
        }
        selectedAntonymTerms.value[vocabularyId].add(termId);
        antonymCheckboxState.value[vocabularyId] = true;
        break; // Stop searching once we find the term
      }
    }
  });

  // Initialize selected synonyms
  data.synonyms.forEach((term: any) => {
    const termId = term.id; // Extract the term ID from the object
    for (const vocabulary of vocabularies.value) {
      // Check each term in the vocabulary's terms array
      const matchingTerm = vocabulary.terms.find((t: any) => t.id === termId);
      if (matchingTerm) {
        const vocabularyId = vocabulary.id;
        // Initialize selectedSynonymTerms if not already set
        if (!selectedSynonymTerms.value[vocabularyId]) {
          selectedSynonymTerms.value[vocabularyId] = new Set();
        }
        selectedSynonymTerms.value[vocabularyId].add(termId);
        synonymCheckboxState.value[vocabularyId] = true;
        break; // Stop searching once we find the term
      }
    }
  });
}

function toggleAllTerms(vocabularyId: string | number, modalType: 'antonyms' | 'synonyms') {
    const selectedTerms = modalType === 'synonyms' ? selectedSynonymTerms : selectedAntonymTerms;
    const termsKey = vocabularyId;
    const vocabulary = vocabularies.value.find(vocab => vocab.id === vocabularyId);

    if (!vocabulary) return;

    // Toggle the state
    const allSelected = !areAllTermsSelected(vocabularyId, modalType); // If all terms are selected, uncheck; else check all
    if (allSelected) {
        // Select all terms
        selectedTerms.value[termsKey] = new Set(vocabulary.terms.map(term => term.id));
    } else {
        // Deselect all terms
        selectedTerms.value[termsKey] = new Set();
    }

    // Update the checkbox state accordingly
    synonymCheckboxState.value[vocabularyId] = allSelected;
}

function toggleTerm(vocabularyId: string | number, termId: string | number, modalType: 'antonyms' | 'synonyms') {
  // Explicitly cast selectedTerms as Ref<Record<string | number, Set<string | number>>>
  const selectedTerms = modalType === 'antonyms'
    ? selectedAntonymTerms.value as Record<string | number, Set<string | number>>
    : selectedSynonymTerms.value as Record<string | number, Set<string | number>>;

  if (!selectedTerms[vocabularyId]) {
    selectedTerms[vocabularyId] = new Set();
  }

  // Toggle the term selection
  if (selectedTerms[vocabularyId].has(termId)) {
    selectedTerms[vocabularyId].delete(termId);
  } else {
    selectedTerms[vocabularyId].add(termId);
  }
}

const collectSelectedTerms = () => {
  // Flatten all term IDs into a single array for antonyms and synonyms
  const antonyms: Array<string | number> = [];
  const synonyms: Array<string | number> = [];

  // Gather all selected antonym IDs
  for (const termSet of Object.values(selectedAntonymTerms.value)) {
    antonyms.push(...Array.from(termSet)); // Flatten Set into the antonyms array
  }

  // Gather all selected synonym IDs
  for (const termSet of Object.values(selectedSynonymTerms.value)) {
    synonyms.push(...Array.from(termSet)); // Flatten Set into the synonyms array
  }

  return {
    antonyms,
    synonyms,
  };
};

const areAllTermsSelected = (vocabularyId: string | number, type: string) => {
    // Get the vocabulary terms
    const vocabularyTerms = vocabularies.value.find(vocab => vocab.id === vocabularyId)?.terms;

    if (!vocabularyTerms) return false;

    // Get the selected terms for the given vocabulary type (synonyms or antonyms)
    const selectedTerms = type === 'synonyms' ? selectedSynonymTerms.value : selectedAntonymTerms.value;

    // Check if all terms in the vocabulary are selected
    const selectedTermIds = selectedTerms[vocabularyId];
    if (selectedTermIds && selectedTermIds.size === vocabularyTerms.length) {
        return vocabularyTerms.every(term => selectedTermIds.has(term.id)); // Check if each term's ID is in the selected set
    }

    return false;
};

</script>